﻿version
6.90
-1
2
pnlCalcNew:fgMouseEvents
frmCalcNew:FormLib
Sub designer
end sub
@EndOfDesignText@
'=======================
'Modulname: mTxtBoxCalc.bas
'=======================
'Ein teil dieses Modul ist abgeleitet von SCalculator,
'ein creation von David Erez.
'
'Grafik und Erweiterungen von Filippo Gozza
'=======================
'Autor:  Filippo Gozza
'E-Mail: filippo2@gmx.de
'=======================
' History:
' 10.08.10  v1.00	Erstellt
'=======================
Sub Globals
	Dim strTextboxName(10) As String
	Dim strFormName(10) As String
	Dim SoundEnabled As Boolean
	Dim IsCreatePanel As Boolean
	Dim intCtr As Integer
	Dim intActivCtr As Integer

	'Default-Color for Function-Buttons 
	Dim FontColor1
	Dim StartColor1
	Dim EndColor1

	'Default-Color for Buttons 0-9
	Dim FontColor2
	Dim StartColor2
	Dim EndColor2

	S=""                 ' register for data input
	Dot_Flag = 0         ' flag for inserting floating point
	Disp = 0             ' register for the display and input
	oper1 = 0            ' operations + , - , %
	oper2 = 0            ' operations * and /
	oper3 = 0            ' operations ^ (power) and n_root
	reg1 = 0             
	reg2 = 0
	reg3 = 0
	deg_flag = 1         ' keeps the status of Degree or Radian calculations
	Eng_flag = 0         ' keeps the status of the display format requests
	Eng_input_flag = 0   ' remember if E was part of the input - means engineering format for the input
	input_flag = 0       ' keeps the status of input or operations
End Sub

Public Sub Initmodul(FormName, TextboxName)
	intCtr=intCtr + 1

	strTextboxName(intCtr)=TextboxName
	strFormName(intCtr)=FormName

	'Default enabled
	SoundEnabled=true

	'##### Buttons color #####
	'Default-Color for Function-Buttons 
	FontColor1=cBlack
	StartColor1=cWhite
	EndColor1=cGray

	'Default-Color for Buttons 0-9
	FontColor2=cWhite
	StartColor2=cGray
	EndColor2=cBlack
	'##################

	if control(strTextboxName(intCtr), Textbox).Multiline then
		intBtHeight=20
	else
		intBtHeight=control(strTextboxName(intCtr), Textbox).Height
	end if
	strButtonCalc= "btnCalc" & intCtr
	AddObject(strButtonCalc,"fggradientbuttons")
	control(strButtonCalc,"fggradientbuttons").New2(strFormName(intCtr),"", cBlack, 10,control(strTextboxName(intCtr), Textbox).Left+control(strTextboxName(intCtr), Textbox).Width-1,control(strTextboxName(intCtr), Textbox).Top,intBtHeight, intBtHeight-1, StartColor1, EndColor1, true,false)
	addevent(strButtonCalc, Click, "btnCalc_Click")
	If ScreenScaleX=2 Then
		control(strButtonCalc,"fggradientbuttons").ImageFile=AppPath &"\grafik\btnDown_vga.PNG"
	else
		control(strButtonCalc,"fggradientbuttons").ImageFile=AppPath &"\grafik\btnDown.PNG"
	end if

	if not(IsCreatePanel) then
		CreatePanel
	end if
End Sub

Sub CreatePanel
	IsCreatePanel = true

	addform("frmCalc","frmCalc")
	frmCalcNew.New1("frmCalc",B4PObject(1))

	'###### Buttons matrix ######
	w=28 :h=20
	x1=2 :x2=2*2+w :x3=2*3+w*2 :x4=2*4+w*3 :x5=2*5+w*4
	y1=2
	y2=2*2+h
	y3=2*3+h*2
	y4=2*4+h*3
	y5=2*5+h*4

	addpanel("frmCalc", "pnlCalc",0,0, 152,112)
	pnlCalcNew.New1("pnlCalc", true)
	pnlCalc.Visible=false

	AddObject("Back","fggradientbuttons")
	Back.New2("pnlCalc","",cBlack,8,x2,y1,w*2 + 2,h, StartColor1, EndColor1,True,True)
	If ScreenScaleX=2 Then
		Back.ImageFile=AppPath &"\grafik\pfeilblack_vga.png"
	else
		Back.ImageFile=AppPath &"\grafik\pfeilblack.png"
	end if

	AddObject("ClearAll","fggradientbuttons")
	ClearAll.New2("pnlCalc","C",FontColor1,11,x4,y1,w*2 + 2,h,StartColor1, EndColor1,True,True)
	ClearAll.FontStyle = ClearAll.FontStyleBold

	AddObject("Divide","fggradientbuttons")
	Divide.New2("pnlCalc","/",FontColor1,8,x4,y2,w,h,StartColor1, EndColor1,True,True)
	Divide.FontStyle = Divide.FontStyleBold

	AddObject("Multiply","fggradientbuttons")
	Multiply.New2("pnlCalc","*",FontColor1,8,x4,y3,w,h,StartColor1,EndColor1,True,True)
	Multiply.FontStyle = Multiply.FontStyleBold

	AddObject("Minus","fggradientbuttons")
	Minus.New2("pnlCalc","-",FontColor1,8,x4,y4,w,h,StartColor1, EndColor1,True,True)
	Minus.FontStyle = Minus.FontStyleBold

	AddObject("Plus","fggradientbuttons")
	Plus.New2("pnlCalc","+",FontColor1,8,x4,y5,w,h,StartColor1, EndColor1,True,True)
	Plus.FontStyle = Plus.FontStyleBold

	AddObject("nine","fggradientbuttons")
	nine.New2("pnlCalc","9",FontColor2 ,8,x3,24,w,h,StartColor2 ,EndColor2 ,True,True)
	nine.FontStyle = nine.FontStyleBold
	addevent("nine", Click, "Calc_Click")

	AddObject("Eight","fggradientbuttons")
	Eight.New2("pnlCalc","8",FontColor2 ,8,x2,24,w,h,StartColor2 ,EndColor2 ,True,True)
	Eight.FontStyle = Eight.FontStyleBold
	addevent("Eight", Click, "Calc_Click")

	AddObject("Seven","fggradientbuttons")
	Seven.New2("pnlCalc","7",FontColor2 ,8,x1,24,w,h,StartColor2 ,EndColor2 ,True,True)
	Seven.FontStyle = Seven.FontStyleBold
	addevent("Seven", Click, "Calc_Click")

	AddObject("Six","fggradientbuttons")
	Six.New2("pnlCalc","6",FontColor2 ,8,x3,y3,w,h,StartColor2 ,EndColor2 ,True,True)
	Six.FontStyle = Six.FontStyleBold
	addevent("Six", Click, "Calc_Click")

	AddObject("Five","fggradientbuttons")
	Five.New2("pnlCalc","5",FontColor2 ,8,x2,y3,w,h,StartColor2 ,EndColor2 ,True,True)
	Five.FontStyle = Five.FontStyleBold
	addevent("Five", Click, "Calc_Click")

	AddObject("Four","fggradientbuttons")
	Four.New2("pnlCalc","4",FontColor2 ,8,x1,y3,w,h,StartColor2 ,EndColor2 ,True,True)
	Four.FontStyle = Four.FontStyleBold
	addevent("Four", Click, "Calc_Click")

	AddObject("Three","fggradientbuttons")
	Three.New2("pnlCalc","3",FontColor2 ,8,x3,y4,w,h,StartColor2 ,EndColor2 ,True,True)
	Three.FontStyle = Three.FontStyleBold
	addevent("Three", Click, "Calc_Click")

	AddObject("Two","fggradientbuttons")
	Two.New2("pnlCalc","2",FontColor2 ,8,x2,y4,w,h,StartColor2 ,EndColor2 ,True,True)
	Two.FontStyle = Two.FontStyleBold
	addevent("Two", Click, "Calc_Click")

	AddObject("One","fggradientbuttons")
	One.New2("pnlCalc","1",FontColor2 ,8,x1,y4,w,h,StartColor2 ,EndColor2 ,True,True)
	One.FontStyle = One.FontStyleBold
	addevent("One", Click, "Calc_Click")

	AddObject("Zero","fggradientbuttons")
	Zero.New2("pnlCalc","0",FontColor2 ,8,x1,y5,w,h,StartColor2 ,EndColor2 ,True,True)
	Zero.FontStyle = Zero.FontStyleBold
	addevent("Zero", Click, "Calc_Click")

	AddObject("ChangeSign","fggradientbuttons")
	ChangeSign.New2("pnlCalc","+/-",FontColor2,8,x2,y5,w,h,StartColor2 ,EndColor2 ,True,True)
	ChangeSign.FontStyle = ChangeSign.FontStyleBold

	AddObject("Dot","fggradientbuttons")
	Dot.New2("pnlCalc",".",FontColor2 ,8,x3,y5,w,h,StartColor2 ,EndColor2,True,True)
	Dot.FontStyle = Dot.FontStyleBold

	AddObject("Root","fggradientbuttons")
	Root.New2(""pnlCalc","√" & Chr(175),FontColor1,8,x5,24,w,h,StartColor1, EndColor1 ,True,True)
	Root.FontStyle = Root.FontStyleBold

	AddObject("Procent","fggradientbuttons")
	Procent.New2("pnlCalc","%",FontColor1,8,x5,y3,w,h,StartColor1, EndColor1,True,True)
	Procent.FontStyle = Procent.FontStyleBold

	AddObject("oneoverx","fggradientbuttons")
	oneoverx.New2("pnlCalc","1/x",FontColor1,8,x5,y4,w,h,StartColor1, EndColor1,True,True)
	oneoverx.FontStyle = oneoverx.FontStyleBold

	AddObject("Equal","fggradientbuttons")
	Equal.New2("pnlCalc","=",FontColor1,8,x5,y5,w,h,StartColor1, EndColor1,True,True)
	Equal.FontStyle = Equal.FontStyleBold
End Sub

Sub btnCalc_Click
	ctr=Sender
	intActivCtr=strreplace( StrToLower(ctr), "btncalc", "")
	pnlCalc.Left=control(strTextboxName(intActivCtr), Textbox).Left
	pnlCalc.Top=control(strTextboxName(intActivCtr), Textbox).top + control(strTextboxName(intActivCtr), Textbox).Height
	frmCalcNew.ChangeParent("pnlCalc", strFormName(intActivCtr))
	pnlCalc.Visible=not(pnlCalc.Visible)
	pnlCalc.BringToFront
	push
End Sub

Sub Calc_Click
	key=sender.text
	PlaySound
	input_flag = 1
	NDisplay(key)
End Sub

Sub Dot_Click
	If Dot_Flag =0 Then 
		PlaySound
		input_flag = 1
		n="."
		Dot_Flag = 1
		If S = "" Then n="0."
		NDisplay(n)
	End If
End Sub

Sub PlaySound
	if SoundEnabled then
		Sound("Sound\Tick.wav")
	end if
End Sub

Sub IsDispNumber
	Disp = control(strTextboxName(intActivCtr), Textbox).Text
	if not(IsNumber(Disp)) then
		msgbox( chr(34) & disp & chr(34) & " is not a number.","ERROR",cMsgBoxOK,cMsgBoxExclamation)
		return false
	else
		return true
	end if
End Sub

'=================
' Operations
'=================
Sub Plus_Click            
	PlaySound
	if not(IsDispNumber) then return
	If input_flag = 1 Then 
		If StrAt(S,StrLength(S)-1)="E" OR StrAt(S,StrLength(S)-1)="-" Then Return
		If S = "." Then Return
	End If
	push
	reg3 = operation(reg3,oper3,disp)
	reg2 = operation(reg2,oper2,reg3)
	reg1 = operation(reg1,oper1,reg2)
	Disp = reg1
	send_to_display(Disp)
	oper1 = 1
End Sub

Sub Minus_Click
	PlaySound
	if not(IsDispNumber) then return
	If input_flag = 1 Then
		If S = "." Then Return
	End If
	If Eng_input_flag = 1 Then 
		If StrAt(S,StrLength(S)-1)="-" Then Return
		S= S&"-"
		control(strTextboxName(intActivCtr), Textbox).Text = S
		Eng_input_flag = 0
		Eng_flag = 1
	Else
		push
		reg3 = operation(reg3,oper3,disp)
		reg2 = operation(reg2,oper2,reg3)
		reg1 = operation(reg1,oper1,reg2)
		Disp = reg1
		send_to_display(Disp)
		oper1 = 2
	End If
End Sub

Sub Multiply_Click
	PlaySound
	if not(IsDispNumber) then return
	If input_flag = 1 Then 
		If StrAt(S,StrLength(S)-1)="E" OR StrAt(S,StrLength(S)-1)="-" Then Return
		If S = "." Then Return
	End If
	push
	reg3 = operation(reg3,oper3,control(strTextboxName(intActivCtr), Textbox).Text) 'Disp)
	reg2 = operation(reg2,oper2,reg3)
	Disp = reg2
	send_to_display(Disp)
	oper2 = 7
End Sub

Sub Divide_Click
	PlaySound
	if not(IsDispNumber) then return
	If input_flag = 1 Then 
		If S = 0 Then Return
		If StrAt(S,StrLength(S)-1)="E" OR StrAt(S,StrLength(S)-1)="-" Then Return
		If S = "." Then Return
	End If
	push 
	reg3 = operation(reg3,oper3,Disp)
	reg2 = operation(reg2,oper2,reg3)
	Disp = reg2
	send_to_display(Disp)
	oper2 = 8
End Sub

Sub Root_Click
	PlaySound
	if not(IsDispNumber) then return
	if control(strTextboxName(intActivCtr), Textbox).Text = "" or Disp <0 then return
		if input_flag = 1 then 
		if StrAt(S,StrLength(S)-1)="E" or StrAt(S,StrLength(S)-1)="-" then return
		if S = "." then return
	end if
	push
	if Disp >= 0 then disp = sqrt(Disp) else return
	send_to_display(Disp)
End Sub

Sub OneOverX_Click
	PlaySound
	if not(IsDispNumber) then return
	if input_flag = 1 then 
		if StrAt(S,StrLength(S)-1)="E" or StrAt(S,StrLength(S)-1)="-" then return
		if S = "." then return
	end if
	if control(strTextboxName(intActivCtr), Textbox).Text = ""  then return
	push
	if Disp <> 0 then Disp = 1/Disp else disp = 0
	send_to_display(Disp)
End Sub

Sub Procent_Click
	PlaySound
	if not(IsDispNumber) then return
	if input_flag = 1 then 
		if StrAt(S,StrLength(S)-1)="E" or StrAt(S,StrLength(S)-1)="-" then return
		if S = "." then return
	end if
	push
	select oper1
	case 1
		oper1 = 3          ' this way it will compute normal percentage addition
	case 2
		oper1 = 5          ' this way it will compute normal percentage subtration
	end select

	select oper2
	case 7
		oper1 = 11          ' this way it will compute normal percentage subtration
	case 8
		oper1 = 12          ' this way it will compute normal percentage subtration
	end select

	reg1 = operation(reg2,oper1,disp)
	Disp = reg1
	send_to_display(Disp)
End Sub

Sub Equal_Click
	PlaySound
	if not(IsDispNumber) then return
	If input_flag = 1 Then 
		If StrAt(S,StrLength(S)-1)="E" OR StrAt(S,StrLength(S)-1)="-" Then Return
		If S = "." Then Return
	End If
	push
	reg3 = operation(reg3,oper3,disp)
	reg2 = operation(reg2,oper2,reg3)
	reg1 = operation(reg1,oper1,reg2)
	Disp = reg1
	send_to_display(Disp)
End Sub

Sub ClearAll_Click         ' clear entry and registers but not memory and constant
	PlaySound
	S=""
	control(strTextboxName(intActivCtr), Textbox).Text = "0"
	Oper1 = 0
	Oper2 = 0
	Oper3 = 0
	input_flag = 0
	Dot_flag = 0
	Disp = 0          
	Eng_input_flag = 0
	reg1 = 0
	reg2 = 0
	reg3 = 0
End Sub

Sub ChangeSign_Click
	PlaySound
	if not(IsDispNumber) then return
	ErrorLabel (errChangeSign)
	If control(strTextboxName(intActivCtr), Textbox).Text = ""  Then Return
	If S = "." Then Return
	If input_flag = 1 Then
		If eng_flag = 0 Then
			S = -S
		Else 
			S = StrReplace(S,"E","E-")
		End If
		control(strTextboxName(intActivCtr), Textbox).Text = S
	Else
		Disp = -Disp
		send_to_display(Disp)
	End If
	errChangeSign:
End Sub

Sub push          ' transfer input data to register 
	If input_flag = 1 Then Disp = control(strTextboxName(intActivCtr), Textbox).Text
	S = ""
	input_flag = 0
	dot_flag = 0
	Eng_input_flag = 0 
End Sub

Sub operation(R1,OP,R2)       ' perform the current numeric operation
	ErrorLabel (errOperation)
	Select OP
	Case 0
		R1 = R2
	Case 1
		R1 = R1 + R2
		oper1 = 0
	Case 2 
		R1 = R1 - R2
		oper1 = 0
	Case 3
		R1 = R1 *(1+ R2/100)
		oper1 = 0
	Case 4 
		R1 = R1 /(1- R2/100)
		oper1 = 0
	Case 5 
		R1 = R1 * (1- R2/100)
		oper1 = 0
	Case 6
		R1 = R1 /(1+ R2/100)
		oper1 = 0
	Case 7
		R1 = R1 * R2
		oper2 = 0
	Case 8
		R1 = R1 / R2
		oper2 = 0
	Case 9
		R1 = R1 ^ R2
		oper3 = 0
	Case 10
		If R1>=0   Then
			R1 =  R1 ^ (1/R2)
		Else
			If Int((R2+1)/2)= (R2+1)/2 Then  
				R1 = -R1
				R1 =  R1 ^ (1/R2)
				R1 = -R1
			Else
				R1 =  R1 ^ (1/R2)          
			End If
		End If
		oper3 = 0
	Case 11
		R1 = R1 * R2 / 100
		oper1 = 0
		oper2 = 0
	Case 12
		R1 = R1 / R2 * 100
		oper1 = 0
		oper2 = 0
	Case Else
	End Select
	Return R1
	errOperation:
End Sub

Sub send_to_display(x)     ' according to the requested or required format
	If x > 10^8 OR eng_flag = 1 Then 
		control(strTextboxName(intActivCtr), Textbox).Text = Format(x,"E3")
	Else
		n=StrIndexOf (x , ".",0)
		If  n>0  AND StrLength(x) - n =>8 Then
			x= Format(x,"F8")
		End If
		If StrLength(x)>9 Then x=SubString(x,0,10)
		control(strTextboxName(intActivCtr), Textbox).Text = x
	End If
End Sub

Sub Back_Click        ' delete the last charachter
	If input_flag = 1 Then
		PlaySound
		If StrLength(control(strTextboxName(intActivCtr), Textbox).Text)>0 Then
			S = StrRemove (control(strTextboxName(intActivCtr), Textbox).Text ,StrLength(control(strTextboxName(intActivCtr), Textbox).Text)-1 ,1)
			control(strTextboxName(intActivCtr), Textbox).Text = S
			If StrLength(control(strTextboxName(intActivCtr), Textbox).Text)=0 Then
				control(strTextboxName(intActivCtr), Textbox).Text = "0"
			End If
		Else
			S="0"
			control(strTextboxName(intActivCtr), Textbox).Text=S
		End If
	End If
	If StrIndexOf (control(strTextboxName(intActivCtr), Textbox).Text , ".",0)<0 Then
		Dot_Flag =0
	End If
End Sub

Sub NDisplay(n)             ' updates the string and display during input
	If StrLength(S) >=9 Then Return
	S = S & n
	control(strTextboxName(intActivCtr), Textbox).Text = S
End Sub
